> For the complete documentation index, see [llms.txt](https://docs.sportradar.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.sportradar.com/uof/sdk/troubleshooting/markets-and-outcomes.md).

# Markets and Outcomes

**1. Sometimes I get an "odds\_change" message from the feed which contains no markets or markets containing no outcomes. Is that OK?**

An "odds\_change" message also contains an "event\_status" element, providing the current status of the associated sport event. An odds\_change message with no markets is therefore sometimes sent by the feed to provide the updated status of the sport event. Worth noting: the "odds\_change" message can come without markets or with markets containing no outcomes.

**2. How to get referenced competitor from outright market outcomes?**

{% code title="JAVA" %}

```java
public void onOddsChange(OddsFeedSession sender, OddsChange<SportEvent> oddsChanges) {
    SportEvent event = oddsChanges.getEvent();
    logger.info("Received odds change for: " + event);
 
    Season season = (Season) oddsChanges.getEvent();
    for (MarketWithOdds market : oddsChanges.getMarkets()) {
        for (OutcomeOdds outcome : market.getOutcomeOdds()) {
            String outcomeId = outcome.getId();
            Competitor competitor = uofSdk.getSportDataProvider().getCompetitor(Urn.parse(outcomeId));
            String competitorReference = competitor.getReferences().getReferences().get("competitor");
        }
    }
}
```

{% endcode %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.sportradar.com/uof/sdk/troubleshooting/markets-and-outcomes.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
